'Well, here it is, the long-awaited library creation tutorial!
'As far as I know it is the only one in existence.  Now before I continue,
'I want to give credit to Enigma who figured out how to make libraries.
'I'm merely putting what he gave me into a program that everyone can learn
'from.  Visit Enigma's site at:
'       http://www.geocities.com/SiliconValley/Lab/2950

'Also, I'm using the CENTER subroutine from Jesse Dorland's QMIDI 2.0 only
'because it is small and clearly shows that the library works.

'As for myself, I am Mike Hoopmann, creator of Dark Ages I: The Continents.
'You can see the rest of my stuff at:
'               http://www.tcnj.edu/~hoopman2

DECLARE SUB Center (write$)    'Subroutine that will be put in QuickLibrary

'Run the program, then read the comments at the bottom for
'further instructions.

CLS
Center "This is what the subroutine does."
Center "Note how the text is centered on the screen."
PRINT : PRINT : Center "Hit any key to continue."
WHILE INKEY$ = "": WEND
CLS
Center "Now lets say that you want to put the 'Center' subroutine in a library"
Center "in order to reduce your code."
PRINT
Center "This is quite simple.  Merely remove all lines of code except for the"
Center "DECLARE statement.  If you have any variables that are SHARED, do not remove"
Center "them.  As you can see, this tutorial has no SHARED variables.  Also,"
Center "any arrays that are used in the subroutines must be DIMmed to 0.  If you"
Center "have more than one subroutine, but want to put only some of them in a library,"
Center "remove the subroutines that you do not want."
PRINT
Center "After you have removed or edited the code, save the file under a different name"
Center "then go to the RUN menu, select MAKE LIBRARY, type in a library name (qlbtutor"
Center "was used in this tutorial) and then select MAKE LIBRARY AND EXIT."
PRINT
Center "After that run QuickBasic again with the flag: /l qlbname"
Center "Now load the ORIGINAL program and run it.  You will be told that the"
Center "subroutine is already defined in the library.  Remove the subroutine"
Center "from your program, but leave the DECLARE statement.  That's it!  Now your"
Center "subroutine works without the code inside your program!  Instead, it's in the"
Center "library!  Read the comments inside this program for further instructions."

'Ok.  This file (QLBTUTOR) is the original program.  Open QLBTUTR2 to see
'what a file should look like before it is turned into a library.  Then
'exit QuickBasic and reload it with the qlbtutor library.

'e.g. qb.exe /l qlbtutor

'Then load QLBTUTR3.  Notice that the DECLARE SUB Center (write$) is still
'there, but the actual subroutine is missing.  Yet the program still works!
'That's because it's in the library.  If you load up the QLBTUTOR file and
'try to run it, it will say subroutine already defined in library.  So
'delete the Center subroutine and the program will work!  It's that simple.
'Don't save over QLBTUTOR, though, as it may ruin this tutorial.  If you
'wish, you could MAKE LIBRARY in QLBTUTR2 under a different name and then
'try loading that library.  It will still work.  Experiment until you get
'comfortable, then make libraries in your own programs. :)

'The comments in this sub were made by Jesse Dorland.  Since I see nothing
'wrong with them, why bother changing them? :)
SUB Center (write$)
'As far as we know, a carriage return should be printed.
NoCR% = 0
'Get the number of screen columns.
DEF SEG = &H40
MaxCol% = PEEK(&H4A) \ 2
DEF SEG
'If the last two characters in the string are semi colons, then a carriage
'return should not be printed.
IF RIGHT$(write$, 2) = ";;" THEN NoCR% = 1: text$ = LEFT$(write$, LEN(write$) - 2)

'Locate the cursor on the appropriate place
LOCATE CSRLIN, MaxCol% - LEN(write$) \ 2, 0
'Print the text.
IF NoCR% THEN
        PRINT write$;
ELSE
        PRINT write$
END IF
END SUB

